package jaredbgreat.dldungeons;

/**
 * An algorithmic multi-room dungeon generator for Minecraft inspired by the 
 * Oblige 3.57 level generator for Doom / Doom II / Heretic / Hexen etc.
 */

/*This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/	


import jaredbgreat.dldungeons.pieces.chests.LootList;
import jaredbgreat.dldungeons.themes.Theme;
import jaredbgreat.dldungeons.themes.ThemeReader;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.Init;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.Mod.PostInit;
import cpw.mods.fml.common.Mod.PreInit;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.network.NetworkMod;


//Temporary stand in names, not for release
@Mod(modid=Info.ID, name=Info.NAME, version=Info.VERSION) 
//Server-side world-gen mod; no new blocks/items/mobs
@NetworkMod(clientSideRequired=false, serverSideRequired=false)       
public class DoomlikeDungeons {
	private static GenerationHandler dungeonPlacer;
	
    @Instance(value = Info.ID)
    public static DoomlikeDungeons instance;
    
    @PreInit
    public void preInit(FMLPreInitializationEvent event) {
    	System.out.println(Info.NAME + " is in preInit, should now load config.");
    	ConfigHandler.init(event.getSuggestedConfigurationFile());
    	System.out.println(Info.NAME + " config should now be loaded.");
    	//LootList.addDefaultLoot();
    }
    
    @Init 
    public void init(FMLInitializationEvent event) {
    	dungeonPlacer = new GenerationHandler();
    }
    
    @PostInit
    public void postInit(FMLPostInitializationEvent event) {
    	ConfigHandler.generateLists();
    	ThemeReader.readThemes();    	
    	
    	
    }
    
    
    
    
    

}
