package jaredbgreat.dldungeons.rooms;

import jaredbgreat.dldungeons.planner.Dungeon;

import java.util.Random;

import net.minecraft.block.Block;

public abstract class AbstractRoom /*extends Shape*/ {


	public Block wallBlock1;
	public Block floorBlock;
	public Block cielingBlock;
	public Block fenceBlock;
	public Block pillarBlock;
	public Block liquidBlock;
	
	public boolean degenerate;			// Leave air blocks in walls / ceiling/
	public boolean degenerateFloors;	// Even leave air blocks in floor?!?
	public boolean sky;					// Does the room have a ceiling? / Is it outdoorsy?
	public boolean fenced;
	
	
	protected AbstractRoom() {
		wallBlock1 = null;
		floorBlock = null;
		cielingBlock = null;
		fenceBlock = null;
		pillarBlock = null;
		liquidBlock = null;
	}
	
	
	public AbstractRoom(Dungeon dungeon, AbstractRoom previous) {
		if((previous != null) && !dungeon.variability.use(dungeon.random)) {
			wallBlock1   = previous.wallBlock1;
			floorBlock   = previous.floorBlock;
			cielingBlock = previous.cielingBlock;
			fenceBlock   = previous.fenceBlock;
			pillarBlock  = previous.pillarBlock;
			liquidBlock  = previous.liquidBlock;
		} else if(dungeon.variability.use(dungeon.random)) {
			if(dungeon.variability.use(dungeon.random)) {
				wallBlock1 = dungeon.theme.walls.choose(dungeon.random);
				floorBlock = dungeon.theme.floors.choose(dungeon.random);
				cielingBlock = dungeon.theme.ceilings.choose(dungeon.random);
				fenceBlock = dungeon.theme.fencing.choose(dungeon.random);
				pillarBlock = dungeon.theme.pillarBlock.choose(dungeon.random);
				liquidBlock = dungeon.theme.liquid.choose(dungeon.random);
			} else {
				if(!dungeon.variability.use(dungeon.random)) 
					wallBlock1 = dungeon.wallBlock1;
				else wallBlock1 = dungeon.theme.walls.choose(dungeon.random);
				if(!dungeon.variability.use(dungeon.random)) 
					floorBlock = dungeon.floorBlock;
				else floorBlock = dungeon.theme.floors.choose(dungeon.random);
				if(!dungeon.variability.use(dungeon.random)) 
					cielingBlock = dungeon.cielingBlock;
				else cielingBlock = dungeon.theme.ceilings.choose(dungeon.random);
				if(!dungeon.variability.use(dungeon.random)) 
					fenceBlock = dungeon.fenceBlock;
				else fenceBlock = dungeon.theme.fencing.choose(dungeon.random);
				if(!dungeon.variability.use(dungeon.random)) 
					pillarBlock = dungeon.cornerBlock;
				else pillarBlock = dungeon.theme.pillarBlock.choose(dungeon.random);
				if(!dungeon.variability.use(dungeon.random)) 
					liquidBlock = dungeon.liquidBlock;
				else liquidBlock = dungeon.theme.liquid.choose(dungeon.random);
			}
		} else {
			wallBlock1   = dungeon.wallBlock1;
			floorBlock   = dungeon.floorBlock;
			cielingBlock = dungeon.cielingBlock;
			fenceBlock   = dungeon.fenceBlock;
			pillarBlock  = dungeon.cornerBlock;
			liquidBlock  = dungeon.liquidBlock;
		}
		if(dungeon.outside.value > 0)
			sky = dungeon.outside.use(dungeon.random);
		if(dungeon.degeneracy.value > 0) {
			degenerate = dungeon.degeneracy.use(dungeon.random);
			degenerateFloors = 
					(degenerate && dungeon.degeneracy.use(dungeon.random) && dungeon.random.nextBoolean());
		}
		if(sky) fenced = dungeon.fences.use(dungeon.random);
		else fenced = false;
	}
	
	
	

	
/* --------------*/
/* Getters Below */
/* --------------*/
	

	Block wallBlock;
	public Block getWallBlock() {
		return wallBlock1;
	}


	public Block getFloorBlock() {
		return floorBlock;
	}


	public Block getCielingBlock() {
		return cielingBlock;
	}


	public Block getFenceBlock() {
		return fenceBlock;
	}


	public Block getCornerBlock() {
		return pillarBlock;
	}


	public Block getLiquidBlock() {
		return liquidBlock;
	}
	
}
